 {~ Times of extrema of variable stars (of eclipses in eclipsing binaries) ~}

{             change line 282:
 if (hodina <= 24 ) and (hodina >= 17 ) or (hodina >= 0 ) and (hodina <= 4) then
to suit your needs for limiting the displayed times
to concern dark hours of your site }

program minimum; {by Ruldolf Novak} {minor modifications by J.Hollan}

uses Crt,Dos,{otp,kur,}un_str_m,printer;

const loc_min_bin='.\;c:\s\pas\astro\min\;c:\d\j\p\astro\min\';

var    minuta,hodina,rok,mesic,den,date,f,jp,m0,p,jul_Pres,jul_apr: real;
       ya,mo,da,rr,mm,dd,ddo,h,min,s,s1:word;
       y,m,d,min1,h1,dd1: real;
       path_o,path,nazev,o_file,rok_s,den_s,mesic_s,p_s,M0_s,pocet_s : string;
       q,ki,pocet,i,pocet_io:integer;
       ch : char;
       namebin,nameidx:pathstr;
       all,fi,I_file,Pth_file : text;
       odpoved : char;
       Full_screen,System_D,Nasel,th : Boolean;
       first,second,third : string;

procedure UpStr(var s:string);
begin
 s:=__cvtstr(s,_to_upcase_str);
end;

procedure delmez(var s:string);
begin
 s:=__cvtstr(s,_rem_white_str);
end;

procedure UN_JD(jul_pres:real;ya,mo,da:real);
var c,z,f,a,alfa,b,x,e : real;
 begin
  z:=int(jul_pres+0.5);
  f:=frac(jul_pres+0.5);
  if z < 2299163 then a:=z;
  if z >=2299163 then
   begin
    alfa:=int((z-1867216.25)/36524.25);
    a:=z+1+alfa-int(alfa/4);
   end;
   b:=a+1524;
   c:=int((b-122.1)/365.25);
   x:=int(365.25*c);
   e:=int((b-x)/30.6001);
   Da:=b-x-int(30.6001*e)+f;
   if E<=13 then Mo:=E-1;
   if e>=14 then Mo:=E-13;
   if Mo>=3 then ya:=c-4716;
   if mo<=2 then ya:=c-4715;
   rok:=ya;mesic:=mo;den:=da;
  end;

procedure write_to_file;
begin
 th:=false;
 first:=paramstr(1);second:=paramstr(2);third:=paramstr(3);
 if paramstr(1) = 'v' then th:=true;
 if th then Upstr(third);
 if not th then third:='';
 UpStr(First);UpStr(Second);
 assign(i_file,first+'_'+second+'.min');
 rewrite(i_file);
 writeln(I_file,'All times in UTC');
 writeln(I_file);
 writeln(I_file,'            Star:  ',first,' ',second,' ',third);
 writeln(I_file,'          Period:  ',p:8:7,' days');
 writeln(I_file,'    Base minimum:  ',m0+2400000:9:4,' JD');
 writeln(I_file,'           Count:  ',pocet);
 writeln(I_file);
end;





procedure info;

begin
 highvideo;
 window(6,2,59,7);
 write('                       [Info]                         ');
 write('    Star:            Year:       Month:       Day:    ');
 write('                                                      ');
 write('  Period:            Base:                  Count:    ');
 write('                                                      ');
 th:=false;
 first:=paramstr(1);second:=paramstr(2);third:=paramstr(3);
 if paramstr(1) = 'v' then th := true;
 if th then upstr(third) else third:='';
  upstr(first);upstr(second);
 gotoxy(10,2); write(first,' ',second,' ',third);
 gotoxy(27,2); write(rr);
 gotoxy(40,2); write(mm);
 gotoxy(51,2); write(dd);
 gotoxy(10,4); write(p:8:7);
 gotoxy(27,4); write(m0:9:4);
 gotoxy(51,4); write(pocet);
  window(1,1,80,24);
writeln('(All times in UTC)');
end;







procedure help;
begin
 highvideo;
 writeln;
 writeln;
 writeln('----------------------------------------------------------------------');
 writeln('                           MIN  <Star> <Count> <D>                 ');
 writeln;
 writeln('                         -----  R.K.Novak  -----                       ');
 writeln('                         (C) Eagle software 1994                       ');
 writeln(' parameter /a will display all stars which reach a minimum today   ');
 writeln(' Examples: "min GR Tau"   will show next 3 times of minimum brightness');
 writeln('           "min GR Tau 5 D" will prompt for starting date');
 writeln('                            and then show 5 moments');
 writeln('-----------------------------------------------------------------------');
 halt;
end;

function JD ( y,M,D : real ) : real;
{vypocet julianskeho data z data tvaru RRRR-MM-DD.DDD}
var a,B,jd1 : real;
begin
if (M=1.0)or(M=2.0) then begin
  y:=y-1.0;
  M:=M+12.0; end;
a:=int(0.01*y);
B:=2-a+int(0.25*a);
jd1:=int(365.25*y)+int(30.6001*(M+1.0))+D+1.7209945E6;
if (y<=1582.0)and(M<=10.0)and(D<15) then
  JD:=a
else
  JD:=jd1+B;
end;

procedure Get_Date;
begin
 getdate(rr,mm,dd,ddo);
 gettime(h,min,s,s1);
 min1:=s/60+min;
 h1:=min/60+h;
 dd1:=h1/24+dd;
end;

procedure parametry;
var n_var:string[5];
begin
    n_var:=paramstr(1);
    nazev:=n_var+' '+paramstr(2);
    o_file:=n_var+'_'+paramstr(2)+'.min';
    if paramcount>2 then pocet_s:=paramstr(3) else pocet_s:='3';
    if (length(n_var)>1) and (ord(n_var[2])<ord('A')) then
      nazev:='V '+copy(n_var,2,length(n_var)-1)+' '+paramstr(2);
    val(pocet_s,pocet,i);
end;



procedure hledej(jmeno:string;a,b:real);

type consti = record
                  zaznam: integer;
                  Jmeno : string[6];
               end;

type nahravka = record
                  P     : extended;
                  M0    : extended;
                  Nazev : string[11];
               end;


var
   name_n,str : string;
            f : file of nahravka;
            g : file of consti;
desti,radka,i,k : integer;
dest,jjmeno,name : string;
     poc_star : real;
     BRNO     : boolean;
      constl  : string;
      br      : consti;
      br1     : nahravka;
begin
  radka:=0;
  nasel:=false;
  i:=0;
  name:=nazev;
  delmez(name);
  upstr(name);
  assign(f,namebin);
  reset(f);
  assign(g,nameidx);
  reset(g);
  if paramstr(1) = 'v' then constl:=paramstr(3) else constl:=paramstr(2);
  upstr(constl);
   repeat
      read(g,br);
      dest:=br.jmeno;
      desti:=br.zaznam;
      upstr(dest);
   until constl<> dest;
  seek(f,desti);
    i:=0;
  while not eof(f) do
   begin
     read(f,br1);
     jjmeno:=br1.nazev;
     delmez(jjmeno);
     upstr(jjmeno);
     if jjmeno=name then
       begin
        nasel:=true;
          P:=br1.p;
         m0:=br1.m0;
         exit;
       end;
      gotoxy(32,3);
      write(i);
     inc(i);
  end;
end;



procedure vypocet_all;
type consti = record
                  zaznam: integer;
                  Jmeno : string[6];
               end;
type nahravka = record
                  P     : extended;
                  M0    : extended;
                  Nazev : string[11];
               end;
var
 
  name_n,str : string;
            f : file of nahravka;
            g : file of consti;
desti,radka,i,k,xpos,ki2 : integer;
             epocha:longint;
dest,jjmeno,name : string;
     poc_star : real;
     BRNO     : boolean;
      constl  : string;
      br      : consti;
      br1     : nahravka;

begin
 nasel:=false;
 ki:=0;
 assign(f,namebin);
 reset(f);
 assign(all,'all.min');
 rewrite(all);
 writeln(all,'Minima for ',rr,'-',mm,'-',dd,', computed for all stars in the catalogue.');
 writeln(all,'Check, if the star is over horizon at all.');
 writeln(all);
 writeln('The result is being written to all.min.');
while not eof(f) do begin
 read(f,br1);
 jjmeno:=br1.nazev;
 P:=br1.p;
 m0:=br1.m0;
 m0:=m0+ 2400000;
 jul_apr:=m0;
 epocha:=trunc(((Jul_Pres-M0)/P)-2);
 Jul_Apr:=M0+epocha*(P);
 un_jd(jul_apr,rok,mesic,den);
 hodina:=frac(den)*24;
 minuta:=frac(hodina)*60;
 den:=round(den);
 if  ((mm=mesic) and (dd=den)) then begin
 if (hodina <= 24 ) and (hodina >= 17 ) or (hodina >= 0 ) and (hodina <= 4)  then
   begin
     writeln(all,jjmeno,'--',int(den):2:0,'.',mesic:2:0,'.',rok:4:0,' -- ',INT(hodina):4:0,'h  ',round(minuta),'m');
     writeln(jjmeno,' ',int(den):2:0,'.',mesic:2:0,'.',rok:4:0,' -- ',INT(hodina):4:0,'h  ',round(minuta),'m');
    end;
  end;
 end;
close(all);
end;


procedure vypocet(jd:real);
var      epocha : longint;
        radka,k : integer;
        radka2 : longint;
        ki2:integer;
        xpos:integer;
begin
    radka:=0;
    m0:=m0+ 2400000;
    jul_apr:=m0;
    epocha:=trunc(   ( (Jul_Pres-M0) /P)           -5);
    Jul_Apr:=M0+epocha*(P);
    while  jul_apr < jul_pres do
    begin
      jul_apr:=jul_apr+p;
    end;
 xpos:=1;
  ki2:=0;
  ki:=0;
  repeat
       un_jd(jul_apr,rok,mesic,den);
       hodina:=frac(den)*24;
       minuta:=frac(hodina)*60;
       if ((hodina <= 24 ) and (hodina >= 19 )) or ((hodina >= 0 ) and (hodina <= 4))  then
          begin
            inc(ki);
            writeln(i_FILE,int(den):2:0,'.',mesic:2:0,'.',rok:4:0,' -- ',INT(hodina):4:0,'h  ',round(minuta),'m');
            gotoxy(xpos,radka+8);
            writeln(int(den):2:0,'.',mesic:2:0,'. -- ',INT(hodina):4:0,'h  ',round(minuta),'m ');
            inc(radka);
            inc(ki2);
            if radka = 14 then
               begin
                radka:=0;
                xpos:=xpos+24;
               end;
           if ki2 > 40 then
            begin
             ki2:=0;
             gotoxy(xpos+10,radka+10);
             writeln('Press a key...');
             ch:=readkey;
             clrscr;
             xpos:=1;
             radka:=0;
             INFO;
            end;
          end;
       jul_apr:=jul_apr+p;
  until ki = pocet;
gotoxy(xpos+10,radka+10);
writeln('Press a key...');
ch:=readkey;
end;

procedure input_date;
begin
writeln;
write('Year:');read(rr);
write('Month:');read(mm);
write('Day:');read(dd1);
clrscr;
end;


begin               {ZZAACCAATTEEKK}
{hide;
}
 clrscr;
 System_D:=true;
 pocet_io:=0;
 if (paramcount = 0) then help;
 if (paramstr(1)='v') or (paramstr(1)='V') then
   begin
    if paramstr(5)='D' then system_d:=false;
    if system_d=false then input_date;
   end;
 if (paramstr(1)<>'v') or (paramstr(1)<>'V') then
  begin
   if paramstr(4)='D' then system_d:=false;
   if system_d=false then input_date;
  end;
 if pos('?',paramstr(1))>0 then help;
 if System_D then get_date;
 jul_pres:=jd(rr,mm,dd1);
 if paramstr(1)= '/a' then
  begin
   vypocet_all;
   writeln;
   writeln;
   writeln('Press a key...');
   ch:=readkey;
   clrscr;
   writeln('This program is public domain from Eagle corporation    R.K. Novak');
   writeln('      -(c) 1994 09 20- Rudolf Karel Novak. Thanx To T.Rezek       ');
   halt;
  end;
parametry;

namebin:=fsearch('min.bin',loc_min_bin);
nameidx:=fsearch('const.idx',loc_min_bin);

 write('Result will be written to the present directory to: *.min');
 writeln;
 writeln;
 write('Searching....  Reading a record:');
 hledej(nazev,m0,p);
 clrscr;
 if not Nasel then
  begin
   window(16,6,60,11);
   highvideo;
   write('                 [ Sorry ]                   ');
   write('  ----------------------------------------   ');
   write('  -   Star was not found. Try again!     -   ');
   write('  ----------------------------------------   ');
   write('                                             ');
   delay(2000);
   window(1,1,80,24);
   clrscr;
   {$I-}
   if not doserror=0 then erase(I_file);
   {$I+}
   exit;
  end;
 
 info;
 write_to_file;
 Vypocet(jul_pres);
 clrscr;
 writeln('This program is public domain from R.K. Novak');
 writeln('      -(c) 1994 09 20- Rudolf Karel Novak. Thanx To T.Rezek       ');
 close(I_File);
 window(1,1,80,24);
 writeln;
 writeln;
 normvideo;
 textcolor(white);
 {SHOW;
 }
end.
