 {~ Sound of a body on a circular orbit: hearing the Doppler effect ~} 

program Doppl{er, by Jenik Hollan};
uses crt;
const
    cl=#13#10;
    base: word = 440; del:byte=3;
var ht,v,pi30,period:real;
    wrong:integer;
    i:word;
begin
 ht:=exp(ln(2)/48)-1;
 pi30:=pi/30;
 if paramcount>0 then
  begin
   val(paramstr(1),v,wrong);
   if wrong=0 then ht:=v/340;
   if Paramcount>1 then
    begin
     val(paramstr(2),i,wrong);
     if wrong=0 then base:=i;
     if Paramcount>2 then
      begin
       val(paramstr(3),period,wrong);
       if wrong=0 then del:=round(period*1000/60);
      end;
    end
  end;
 i:=1;
 while not keypressed do
  begin sound(round(base/(1-ht*sin(pi30*i)))); delay(del); i:=succ(i); end;
 nosound;
 writeln('Doppl [ <orbital velocity / (1 m /s)>' ,cl,
         '      [ <sound frequency / 1 Hz>'       ,cl,
         '      [ <period / 1 s> ]]]'            ,cl,
         'simulates a sound source (default 440 Hz) at a circular trajectory'
 ,cl, 'in a plain going through you. Default orbital velocity is some',cl,
 '5 m/s (i.e., total frequency span of a quarter-tone).',cl,cl,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
end.
