 {~ MS-DOS-type text file to UNIX-type one ~}

Program crlf_to_lf;

const cl=#13#10;
h1= cl+
'CRLF2LF <input text file with CR LF ends of lines>'+cl+
'        <output text file with just LF end of lines (UNIX type)>'+cl
                                                     +cl+
' converts DOS text files to UNIX text files'+cl;
h2=
''+cl;
h3= cl+
'Jan Hollan (hollan@ped.muni.cz) made for Rudolf Novak in January, 1997'+cl+
'(source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;


const
 Size_of_Buf=30000;
 NoEsc:boolean=true;
var
  bi,bo: array[1..Size_of_Buf] of byte;
  ci: array [1..Size_of_Buf] of char absolute bi;
  co: array [1..Size_of_Buf] of char absolute bo;
  w,x,NumRead,NumWritten: word;
  inp,out: file;
  aux_s:string;

procedure help(message:string);
  begin
   writeln(message);
   write(h1); write(h2); write(h3); HALT
  end;


begin
 IF pARAMCOUNT<2 THEN HELP('');
{$I-}
 assign(inp,paramstr(1));
 reset(inp,1);
 if IORESULT<>0 THEN
  begin
   aux_s:=ParamStr(1);
   if not ((aux_s[2]='/') or (aux_s[2]='?')) then
    help('There is no file >'+ParamStr(1)+'< in this directory!')
   else help('')
  end;
 assign(out,paramstr(2));
 rewrite(out,1);
 if IORESULT<>0 THEN
  begin
   aux_s:=ParamStr(2);
   if not ((aux_s[1]='/') or (aux_s[1]='?')) then
    help('Cannot open an output file >'+ParamStr(2)+'< !')
   else help('')
  end;
{$I+}
 BlockRead(inp,bi,Size_of_Buf,NumRead);
 x:=0;
 while NumRead>0 do
  begin
   for w:=1 to NumRead do
     begin
      inc(x);
      if bi[w]=13 then
       dec(x)
      else
       bo[x]:=bi[w];
     end;
   BlockWrite(out,bo,x,NumWritten);
   if NumWritten<x then help('Disk full, cannot write the ouptut file!');
   BlockRead(inp,bi,Size_of_Buf,NumRead);
   x:=1;
  end;

 close(inp);
 close(out)
end.
