  {~ Czech only, for making *.dst files for the T602 editor ~}

  { Has to be converted to the appropriate code page;
   the original one is 'Kamenicky'}

program DstDec; {pevd textov sekvence ve vkonn sti soubor .dst
                      zanajc prvnm \ i $ jako soust povel,
                      ppadn ^ - ten se vynech,
                                   a jeho dal vskyty se pelo jako 27,
                      a konc rkou  i EOL
                na sekvence jejich dekadickch kd oddlench mezerami
                        verze 1.2, 93-11-15    Jan Hollan.}
const cl=#13#10;
var vstup,vystup:string[50];
    vst,vyst: text;
    InStr: string;
    i,start: byte;
    fin: integer;
    ByStr: array [0..255] of byte absolute InStr;
    trans2esc:boolean;

procedure Help;
begin
writeln(cl,
'Program DstDec vytv "Definin soubor tiskrny" (.dst) pro editor T602',cl,
'z pedlohy, kter me bt zsti "textov", tj. msto sti posloupnosti',cl,
'dekadickch kd znak, kter se maj vyslat, v n lze znaky pst textov.',cl,
cl,
'     Textovou sekvenci, kter se m peloit do sekvence dekadickch kd,',cl,
'lze zahjit bu znakem ^ (ten pi pekladu vynech), nebo znakem $ i \ ',cl,
'(ty se pelo - vhodn pro LATeX), ukonit ji lze rkou (nepekld se)',cl,
'nebo koncem dku (EOL). Dal znaky ^ v sekvenci zahjen ^ se pekldaj',cl,
'jako Escape.',cl,cl,

'(1993-11-15             Jan Hollan, Hvzdrna a planetrium, 616 00  Brno',cl,
' en dle GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' zdroj viz http://astro.sci.muni.cz/pub/hollan/programmes)'
);

halt;
end;

function MaxI(x,y:integer):integer;
begin if x>=y then MaxI:=x else MaxI:=y end;
function MinI(x,y:integer):integer;
begin if x<=y then MinI:=x else MinI:=y end;
function MinNat(x,y:integer):integer;
begin if MinI(x,y)>0 then  MinNat:=MinI(x,y) else MinNat:=MaxI(x,y) end;

begin
    if Paramcount=0 then
      begin
        writeln('Vstupn soubor (s textovmi sekvencemi k peloen):');
        readln(vstup);
        if (vstup='') or (vstup='?') or (vstup='/?') then help;
      end
    else
      begin
        vstup:=Paramstr(1);
        if pos('?',vstup)>0 then help;
          if ParamCount>1 then
            vystup:=ParamStr(2)
          else
            vystup:=copy(vstup,1, MinNat (pos('.',vstup)-1,Length(vstup)) )
                   +'.dst';
      end;
    assign(vst,vstup);
    reset(vst);
    assign(vyst,vystup);
    reWRITE(vyst);
    repeat
      Readln(vst,InStr);
      start:=MinNat( pos('$',InStr), pos('\',InStr) ) ;
      start:=MinNat(start, pos('^',InStr));
      if start>0 then
        begin
          fin:= pos(',',InStr)-1 ; if fin=-1 then fin:=ByStr[0];
          write(vyst,copy(InStr,1,start-1));
          if start=pos('^',InStr) then
           begin
            inc(start);
            trans2esc:=true;
           end
          else trans2esc:=false;
          for i:= start to fin do
           if trans2esc and (InStr[i]='^') then
            write (vyst,'27 ')
           else
            write(vyst,ByStr[i],' ') ;
          writeln(vyst,copy(InStr,fin+1,ByStr[0]-fin)) ;
        end
      else
        writeln(vyst,InStr);
    until eof(vst);
    close (vst); close(vyst);
end.
