             {in Czech}
program TiskCS;

uses printer,crt,
      angles_o;

const cl=#13#10;
hlptxt1=cl+
'Tisk souboru (PARAMETR 1) v kdu Kamenickch na tiskrn CS 212-25;'+cl+
'  samostatn nuly pitom nahrazuje mezerami.'                       +cl+
'Tiskne pp. nkolik sloupc (PARAMETR 2) vedle sebe.'              +cl+
'Zalamuje dky del ne (PARAMETR 3, default: 127) znak.'         +cl;
hlptxt2=
'Jan Hollan, Hvzdrna a planetrium M.Kopernka v Brn, 1994-05-05, ver.1.'+
cl+
' zdrojov kd viz http://astro.sci.muni.cz/pub/hollan/programmes.'+cl;


 pokyn   :string[16]='F0209B0260';{8 dk na palec a tomu odp.dlka str.}
 Lin_p_Page:byte= 92;               {max. poet dk 92 (+ 1 s . strany)}
 NoCol   :byte=  1;                 {poet sloupc 1}
 NextCol :byte=  0;                 {dal sloupec o 0 znak dl}
 MaxWidth=127;                 {max ka sloupce}
 NoRow   :byte=  1;                 {inicializace sla dku}
 Col     :byte=  1;                 {inicializace sla sloupce}
 PageNo  :byte=  1;                 {prvn strnka, kter se m tisknout}

var vstup,vystup:string[30];
    radekStr : string[MaxWidth];
    radekByte: array[0..MaxWidth] of byte absolute radekStr;
    vst,out: text;
    hr,dr,i,j,LeftMar,Page:byte;
    NoStCol,k : byte;
    Mezera, Nula: boolean;
    PageNoC, C: string[2];
    CB : array [0..1] of byte absolute C;
    Code : integer;
    Column : array [1..2,1..96] of string [65];
    Start : char absolute Column;

{    lst : text;
 }
const LastCol : boolean = False;
      Stop    : Boolean = False;

function BreaT : boolean;
var c: char;
begin
     BreaT:= False; Stop:= False;
     if KeyPressed then
      begin
        while KeyPressed do c:=readkey;
        write('Pokraovat v tisku? (pokun ne, stiskni N): ');
        c:= ReadKey; writeln(c);
        if (c='n') or (c='N') then begin BreaT:= True; Stop:= True end
      end;
end;

Procedure Help;
begin
writeln(hlptxt1);
writeln(hlptxt2);
halt;
end;

function Trans(i:byte):byte;
{ Transformuje znak z kdu Kamenickch do kdu Koi8 tiskrny CS 212-25 }
begin
     if i > 127 then
      begin
       case i of
       {}    128 : i := 227 ;
       {}    129 : i := 200 ;
       {}    130 : i := 215 ;
       {}{} 131 : i := 196 ;
       {}    132 : i := 209 ;
       {}{} 133 : i := 228 ;
       {}{} 134 : i := 244 ;
       {}    135 : i := 195 ;
       {}{} 136 : i := 197 ;
       {}{} 137 : i := 229 ;
       {}{} 139 : i := 233 ;
       {}{} 140 : i := 204 ;
       {nl}   141 : i :=  13 ;
       {}    142 : i := 241 ;
       {}    143 : i := 225 ;
       {}    144 : i := 247 ;
       {}{} 145 : i := 218 ;
       {}{} 146 : i := 250 ;
       {}    147 : i := 208 ;
       {}    148 : i := 205 ;
       {}{} 149 : i := 239 ;
       {}    150 : i := 202 ;
       {}    151 : i := 245 ;
       {}    152 : i := 217 ;
       {}    153 : i := 237 ;
       {}    154 : i := 234 ;
       {}{} 155 : i := 243 ;
       {}    156 : i := 236 ;
       {}{} 157 : i := 249 ;
       {}    158 : i := 242 ;
       {}    159 : i := 212 ;
       {}{} 160 : i := 193 ;
       {}{} 161 : i := 201 ;
       {}    162 : i := 207 ;
       {}    163 : i := 213 ;
       {}    164 : i := 206 ;
       {}    165 : i := 238 ;
       {}    168 : i := 211 ;
       {}    169 : i := 210 ;
       {}    170 : i := 198 ;
       {}    171 : i := 230 ;
       end;
       Mezera:=False;
       Nula:=False
      end
      else if i=32 then Mezera:=True
            else if (i=48) and Mezera then begin Nula:=True; Mezera:=False end
               else begin Mezera:=False; Nula:=False end;
     Trans:= i ;
end;

procedure Ret;
{ Naten etzce a jeho konverze do Koi8 -
    navc se osamocen nuly nahrad mezerami. }
begin
    Nula:=False; Mezera:=False;
    read(vst,radekStr);
    dr := RadekByte[0];
    if dr>0 then
    begin
     for j:= 1 to dr do
       begin
         RadekByte[j] := Trans(RadekByte[j]);
         if (RadekByte[j]=32) and Nula then RadekByte[j-1]:=32
       end;
     if Nula then RadekByte[dr]:=32
    end
end;

Procedure UseRow;
begin
if NoCol=1 then begin writeln(lst,RadekStr); inc(NoRow); end
else
   if LastCol then
     begin
       for j:=1 to NoStCol do
        begin
          dr := length (Column[j,NoRow]) ;
          write(lst,Column[j,NoRow]);
          for k:= 1 to (NextCol-dr) do write(lst,' ');
        end;
       writeln(lst, RadekStr) ;
       inc(NoRow) ;
     end
   else
     begin
       Column[Col,NoRow]:= RadekStr;
       inc(NoRow);
     end;
end;

procedure MAIN;

begin
       write(lst,pokyn);
       Page:=1;
       if PageNo>1 then while Page<PageNo do {nalezen poadovan strnky}
         begin
           readln(vst,C);
           if (CB[0]=1) and (CB[1]=12) then Inc(Page);
         end;
       writeln(lst,'strana ',Page);  {nadepsn sla strnky}

       repeat
(*      for i:= 1 to 4 do readln(vst); {peskoen przdnch dek ReportForm}
  *)
        repeat
         Ret;
         UseRow;
{        writeln(lst,RadekStr);  - opis hlaviky (je suspendovn)}
         while dr=MaxWidth do         {dek del je zalmn }
           begin
            Ret;
            UseRow;
           end;
         readln (vst);            {konec dku}
        until (RadekByte[1]=12) or eof(vst) or (NoRow>Lin_p_Page) or BreaT;

        if Stop then halt;

      if (NoCol>1) then   {pro sloupcov tisk}
       begin
        if eof(vst) and (NoRow<Lin_p_Page) then  {dotisk bufferu}
          begin
            if Col=1 then Lin_p_Page:= NoRow;
            if LastCol then NoStCol:=Col-1 else
                            begin  NoStCol:=Col; NoRow:=1; end;
            LastCol:= True;
            while NoRow<=Lin_p_Page do
              begin
                RadekStr:='';
                UseRow;
              end;
            halt                   {konec}
          end;

        inc(Col);

        if LastCol then           {Vytitna cel strana, inicializace nov}
          begin
            LastCol:= False;
            Col:= 1;
            FillChar(Start, SizeOf(Column), #0);
            writeln(lst,#12,'strana ',Page);  {nov strnka}
          end;

        if Col=NoCol then    {U je sloupc dost, pi ptm se tiskne.}
          begin
            NoStCol:= Col-1;
            LastCol:= True;
            inc(Page);
          end;
       end
      else
       if not eof(vst) then
         begin
           inc(Page);
           writeln(lst,#12,'strana ',Page);  {nov strnka}
         end;
      NoRow:= 1;

       until eof(vst) or Stop;
       close(vst);

end;


begin
    if paramcount=0 then help;
    if not rt_reset('',vst,paramstr(1)) then help;
    if paramcount>1 then
     begin
      val(Paramstr(2),NoCol,code);
      if code>0 then help;
      if paramcount>2 then
       begin
        writeln('parametr 3 nefunguje - nutno prelozit s takovou MaxWidth');
        {val(Paramstr(3),MaxWidth,code);
        if code>0 then} help;
       end
     end;
    vystup:='lst' {'f:tisk.prn'};
    FillChar(Start, SizeOf(Column), #0);  {nulovn bufferu}


    if(vystup='lst')or(vystup='prn')then
                                        {Rovnou tisk}
      MAIN

    else
                        {Do souboru}
      begin
         if not (rt_rewrite(lst,vystup)) then help;
         MAIN;
         close(lst);
      end;

end.