 {~ Redirects prints to a file ~}

program prntofil;  {in Slovak; obtained from some BBS:
              "Ver 1.0  (c) 1991  HAM Software    (Bajt 9/91)"
                 redirects prn to a file; English output by Jenik Hollan}

{$M 8192,0,0}
{$V-,D-,I-,R-,S-}


uses Crt,Dos;

var  regs       : registers;
     tt         : file;         {Sem sa bude ukladat "tlac"}
     Dir        : string[80];   {Adresar}
     BackSlash  : string[1];
     meno       : string;
     Buf        : array[0..64000] of char;
     Command    : string[127];  {prikaz vstupujuci z DOS-u}
     OldVec17   : pointer;      {Vektor starehp preeusenia}
     i,j,k      : byte;
     bj,result  : word;
     tlacit     : boolean;
     FDir: DirStr; Fname: NameStr; Fext: ExtStr;

Function Ex(s:string):boolean;   {testuje retazec 'exit'}
begin
     for i:=1 to 4 do s[i]:=UpCase(s[i]);
     s[0]:=#4;
     if s='EXIT' then Ex:=true  else Ex:=false;
end;

Procedure Prn(AX,BX,CX,DX,SI,DI,DS,ES,BP: word); interrupt;
begin
     if ((Lo(AX)<>0) and (bj<64000)) then {ak chceme 'tlacit' znak}
     begin
          Buf[bj]:=Chr(Lo(AX));   inc(bj);
          if bj=64000 then {pri preplneni zapiska a ignoruje dalsie znaky}
          begin
               Sound(1760);  Delay(100);  NoSound;  Delay(100);
               Sound(1760);  Delay(100);  NoSound;
          end;
     end;
     AX:=$10;               {odpoved "tlaciarne"}
     tlacit:=True;          {tlacenie (SAVE) suboru zapnute}
end;

Procedure TlacDoSuboru;
begin
   FileMode:=2;
     Reset (tt,1);
     Seek (tt,FileSize(tt));         {nastavenie na koniec suboru}
     BlockWrite (tt,Buf,bj,result);  {zapisanie buf-feru}
     Close (tt);
   FileMode:=0; {will open the files by reset as Read Only}
     tlacit:=False;
     bj:=0;
end;


begin
    {write (#10#13'PRNTOFIL     presmeruje tlac do suboru na disk.');}
     write (#10#13'PRNTOFIL     redirects printing to a disk file.');
     writeln ('Ver 1.0  (c) 1991  HAM Software    (Bajt 9/91)');
     GetDir (0,Dir);
     if Dir[Ord(Dir[0])]='\' then BackSlash:=''
        else BackSlash:='\';
     if ParamCount<1 then begin   {pri spusteni nie je zadany parameter}
        meno:='file.prn';
        writeln;    {writeln ('Pouzitie prntofil [menosuboru]');}
                    writeln ('Usage:',#13#10#10,
                             'prntofil [filename (default: file.prn)]');
        end
        else meno:=ParamStr (1);
     writeln;
    {writeln ('Meno suboru pre zapis :',meno);
     writeln ('Ukoncenie programu:  exit');}
     FSplit(meno,Fdir,Fname,Fext);
     if FDir='' then
      begin
       FDir:=GetEnv('TMP');
       if FDir='' then
        FDir:=GetEnv('TEMP');
       if FDir<>'' then
        if FDir[length(FDir)]<>'\' then FDir:=FDir+'\';
      end;
     meno:=FDir+Fname+Fext;
     writeln ('Output file containing the print:',meno);
     writeln ('Uninstall the programme by command:  exit');


     Assign (tt,meno);   Rewrite(tt);
     Close (tt);
     tlacit:=False;   bj:=0;
     GetIntVec ($17,OldVec17);
     SetIntVec ($17,@Prn);
     repeat
           if tlacit then TlacDoSuboru;
           GetDir (0,Dir);
           Write ('<PRNTOFIL> ',Dir,'>');
           ReadLn (Command);
           if not Ex(Command) then begin
              SwapVectors;
              Exec (GetEnv('COMSPEC'),'/C'+Command);
              if DosError <>0 then
                {writeln ('Neda sa spustit COMMAND.COM');}
                writeln ('COMMAND.COM not found.');
              writeln;
           end;
     until Ex(Command);  {pokial prikaz ne je "exit"}
     SetIntVec ($17,OldVec17);
end.
