 {~ SBIG-like "Flat-field" transformation of an image by ST4 CCD camera ~}

Program ST4_flat_field;

const cl=#13#10;
h1= cl+
'S4Fa <net picture name (*.s4a)> <net uniform illuminance file (*.s4a)>'+cl
                                                     +cl+
' does a flat field transformation of a picture'+cl+
' to: buf1[m,k] * Average div buf[m,k]; overflow is preserved.'+cl+
' A new file *.s4f is created.'+cl;

dfs1:string[15]=
'Unif.illum.file';
dfs2:string =
') flat field';
{
 Picture taken 08/02/94 at 02:18:20}
const sum_pix:longint=0;
var
  buf,buf1: array[1..166,1..192] of byte;
  m,k: byte;
  inp: file;
  aux_s:string;
  NumRead:word;
  average:word;
  aux_l:longint;

procedure help;
  begin
   write(h1); HALT
  end;


begin
 IF pARAMCOUNT<2 THEN HELP;
{$I-}
 assign(inp,paramstr(2));
 reset(inp,192);
 if IORESULT<>0 THEN 
  begin 
   aux_s:=ParamStr(2);
   if not ((aux_s[2]='/') or (aux_s[2]='?')) then
    writeln('There is no file >',ParamStr(2),'< in this directory!');
   help
  end;
 BlockRead(inp,buf,166,NumRead);
 for m:=2 to 164 do for k:=1 to 192 do inc(sum_pix,buf[m,k]);
 average:=sum_pix  DIV (163*192);
 close(inp);
 assign(inp,paramstr(1));
 reset(inp,192);
 if IORESULT<>0 THEN
  begin
   aux_s:=ParamStr(1);
   if not ((aux_s[1]='/') or (aux_s[1]='?')) then
    writeln('There is no file >',ParamStr(1),'< in this directory!');
   help
  end;
{$I+}
 BlockRead(inp,buf1,166,NumRead);
 close(inp);
 for m:=1 to 165 do for k:=1 to 192 do
  if buf[m,k]=0 then
   if buf1[m,k]>0 then buf1[m,k]:=255
   else buf1[m,k]:=0
  else
   begin
    aux_l:=buf1[m,k] * Average DIV buf[m,k];
    if (aux_l>255) or (buf1[m,k]=255) then buf1[m,k]:=255
    else buf1[m,k]:=aux_l
   end;
 m:=2;
 move(dfs1[1],buf1[166,121],15);
 move(buf[166,15],buf1[166,136],21);
 dfs2:=' ('+paramstr(2)+dfs2;
 move(dfs2[1],buf1[166,157],length(dfs2));
 if pos('.',paramstr(1))>0 then
  assign(inp,copy( paramstr(1),1,pos('.',paramstr(1)) )+'s4f')
 else
  assign(inp,paramstr(1)+'.s4f');
 rewrite(inp,192);
 BlockWrite(inp,buf1,166,NumRead);
 close(inp)
end.

