 {~ Difference of Faintnesses / 1 mag --> Ratio of Brigtnesses ~}

Program Dif2Rat; {by Jan Hollan}
uses str_num;
var
 LnM,V:real;
 i:integer;

 procedure help;
  begin
   writeln(cl+
'Dif2Rat < { <difference of faintnesses> | <faintness 1> <faintness 2> } /1 mag >'+cl+
    '      computes a ratio of brightnesses',cl2,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);

   halt
  end;

begin
LnM:=Ln(10)/2.5;
if (paramcount<1) then help;
if (pos('?',paramstr(1))>0) or (pos('-h',paramstr(1))>0) then help;
V:=N_S(paramstr(1));
if paramcount > 1 then
 V:=V-N_S(paramstr(2));
writeln('The brightness ratio is ',exp(V*LnM):6:3)
end.
