@echo off
echo A map from the Bright Stars Catalog,
echo                    centered on the planet
echo  whose number (0: Sun, 1: Mercury, ... 9: Pluto, 10:Moon)
echo            is given as a first parameter (used just for centering the map)

shift
echo on
planet c c%0 %1 %2 %3 %4 %5 %6 %7 %8 %9 > %temp%RADecl.tmp
@echo off
if errorlevel==1 goto map
echo                    -------------------
echo Sorry, the parameters supplied conflict with the Plan ephemeris programme.
goto end
:map
map_bsc @%temp%RADecl.tmp r10 b-50 pl+ ie ls5 gr35 %1 %2 %3 %4 %5 %6 %7 %8 %9
:end
