 {~ Example of precession from B1950 to J2000, for file Planets.dbf ~}

program pre_d_BJ; {converts B1950.0  (in degrees) to J2000.0
                   - in this case, in the file planets.dbf
                   J. Hollan}

uses precesse, DbBridge;
var RA,Decl:real; j,dd:integer; hh,mm,ss,RA_n,Decl_n: byte; NoR:word;

begin
if not DbInit('planets.dbf') then
 begin
  writeln(
'Just an example of a one-purpose precession programme. See the source code.');
  halt;
 end;
RA_n:=DbFieldNum('N_pol_RA');
Decl_n:=DbFieldNum('N_pol_DEcl');
if not PrecInit(1950,2000) then halt;
NoR:=1;
while DbRead(NoR,rec) do
 begin
  val(rec[RA_n],RA,j);
  val(rec[Decl_n],Decl,j);
  Precess(RA,Decl);
  DbWrNum(RA_n,RA);
  DbWrNum(Decl_n,Decl);
  if DbWrite(NoR,rec) then;
  inc(NoR)
 end;
DbClose;
end.
