 {~ Cuts away trailing spaces (empty ends of lines) ~}

program CutTrBla; {Discards blanks at the ends of lines of a text file.
             May be used, e.g., for shortening of files obtained from
             "*.dbf" by a dBase command "copy to" ... "sdf".
                   (The lines are to be under 256 characters long.)
                   }

uses un_str_m;
var vstup: string;
    vst,vyst: text;
begin
 if paramcount>0 then
  if pos('?',paramstr(1))=0 then
  begin
    assign(vst,ParamStr(1));
    reset(vst);
    if ParamCount>1 then
      assign(vyst,ParamStr(2))
     else
      assign(vyst,copy(ParamStr(1),1,pos('.',ParamStr(1)))+'cut') ;
    rewrite(vyst);
    repeat
        Readln(vst,vstup);
        Writeln(vyst,__cvtstr(vstup,_rem_trail_white_str)) ;
    until eof(vst);
    close (vst); close(vyst);
    exit
  end;
 writeln(#13#10,'CutTrBla <input file> [<output file>]');
 writeln;
 writeln('Progam cuts the trailing blanks of records of a text file');
 writeln(' - e.g., records of fixed length converts to variable length.');
 writeln('Default output file name is *.cut.');
writeln(#10,
'Jan Hollan, N.Copernicus Obs. and Planetarium, Brno, 1994-01-18,'
,#13#10,
'source code available at http://astro.sci.muni.cz/pub/hollan/programmes.'
);
end.
