 {~ discards comment lines from a *.ps file ~}

Program dis_comm;

const cl=#13#10;
h1= cl+
'dis_comm <input PostScript (or TeX) file>'+cl+
'         <ouptut file with lines beginning with single % discarded>'+cl
                                                     +cl+
' makes PostScript files smaller by discarding ordinary comment lines.'+cl;
h2= cl+
' Do not use for files with images coded by using letters including % sign'+cl+
' (e.g., made by the psgray device of GhostScript).'+cl+
' The programme has been made to discard the Preview part from Alchemy output.'+cl;
h3=cl+
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;


const
 Size_of_Buf=20000;
 DSize_of_Buf=40000;
 NoEsc:boolean=true;
 cp='%';
 NewLine:boolean=true;
var
  bi: array[1..Size_of_Buf] of byte;
  bo: array[1..Size_of_Buf] of byte;
  ci: array [1..Size_of_Buf] of char absolute bi;
  co: array [1..Size_of_Buf] of char absolute bo;
  w,x,NumRead,NumWritten: word;
  inp,out: file;
  aux_s:string;
  AcceptLine, Start:boolean;

procedure help(message:string);
  begin
   writeln(message);
   write(h1,h2,h3); HALT
  end;


begin
 IF pARAMCOUNT<2 THEN HELP('');
{$I-}
 assign(inp,paramstr(1));
 reset(inp,1);
 if IORESULT<>0 THEN
  begin
   aux_s:=ParamStr(1);
   if not ((aux_s[2]='/') or (aux_s[2]='?')) then
    help('There is no file >'+ParamStr(1)+'< in this directory!')
   else help('')
  end;
 assign(out,paramstr(2));
 rewrite(out,1);
 if IORESULT<>0 THEN
  begin
   aux_s:=ParamStr(2);
   if not ((aux_s[1]='/') or (aux_s[1]='?')) then
    help('Cannot open an output file >'+ParamStr(2)+'< !')
   else help('')
  end;
{$I+}
 BlockRead(inp,bi,Size_of_Buf,NumRead);
 x:=1;
 while NumRead>0 do
  begin
   for w:=1 to NumRead do
     begin
      if NewLine then
        begin
         AcceptLine:=not(ci[w]=cp); Newline:=false; Start:=not AcceptLine
        end
      else
       if Start then
        begin
         AcceptLine:=ci[w]=cp;
         if AcceptLine then begin co[x]:=cp; inc(x) end;
         Start:=false
        end;
      if bi[w]=10 then NewLine:=true;
      if AcceptLine then begin bo[x]:=bi[w]; inc(x) end;
     end;
   dec(x);
   BlockWrite(out,bo,x,NumWritten);
   if NumWritten<x then help('Disk full, cannot write the ouptut file!');
   BlockRead(inp,bi,Size_of_Buf,NumRead);
   x:=1;
  end;

 close(inp);
 close(out)
end.
