 {~ Inserting \par or <p> after hard returns, or <p> after blank lines ~}

program hr_to_par ; {hard return or blak line to paragraph, by J.Hollan}
uses dos,crt, angles_o;
var inFile, outFile: text;
    Outname: string;
    L: array[1..8] of string;
{    j:byte;}
    answ:string[1];
const
 parn:byte=1;
 InsStr:string='\par';
 behind:boolean=false;
 empty:boolean=false;
 wasEmpty:boolean=false;
 cl=#13#10;

procedure help;
begin
write(cl,

'HR2Par writes'+cl+
'     \par at the and of all non-empty lines with hard return',cl,
'  or another hard return instead of \par, with an /h switch,',cl,
'  or <p> behind the hard return, with an /p switch,',cl,
'  or <p> behind the empty line(s), with an /e switch:',cl,cl,

'HR_Par [{/h | /p | /e}] <input file> [output file]',cl,cl,

'(output file default suffix is .par, hard return is the <CR><LF> pair)',cl,cl,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
,cl);

halt;
end;

begin
if (paramcount<1) or ((paramcount>0) and (pos('?',paramstr(1))>0)) then
 help;
L[1]:=paramstr(1);
if L[1,1] in ['/','-'] then
 begin
  case UpCase(L[1,2]) of
   'H': InsStr:=cl;
   'P': begin InsStr:='<p>'; behind:=true; end;
   'E': begin InsStr:='<p>'; behind:=true; empty:=true end;
  end;
  inc(parn);
 end;
if not rt_reset('',inFile,paramstr(parn)) then halt;
 if paramcount<parn+1 then
  outName:=copy(paramstr(parn),1,pos('.',paramstr(parn)))+'par'
 else
  outName:=paramstr(parn+1);
 if FSearch(outName,'')<>'' then
  begin
   writeln('The output file >',outNAme,'< exists, overwrite? (Y/n)');
   readln(answ);
   if (answ<>'') and (answ[1] in ['n','N']) then
    begin close(InFile);  halt end
  end;
 if not rt_rewrite(outFile,outName) then begin close(InFile); halt end;
 while not eof(inFile) do
 begin
  readln(inFile,L[1],L[2],L[3],L[4],L[5],L[6],L[7],L[8]);
  if not ((L[1]='')
          or  (L[1][1]='@') {this for sake of the T602 editor}) then
   if not behind then
     L[8]:=L[8]+InsStr
   else
    if empty then
     begin
      if wasempty then
       begin writeln(OutFile,InsStr); wasempty:=false; end
     end
    else
     L[8]:=L[8]+cl+InsStr
  else if L[1]='' then Wasempty:=true;
  writeln(OutFile,L[1],L[2],L[3],L[4],L[5],L[6],L[7],L[8]);
 end;
close(inFile);
close(outFile);
end.
