program Repla; {Replaces the given place in file by another file
                        93-01 Jan Hollan.}

uses dos;
 procedure help;
  const cl=#10#13;
  begin
   writeln(cl,
'Repla <file to be changed> <replacement file> <#>',cl,
cl,
'replaces a part of the first file by the second one, starting at byte #.',cl,
'Use with caution: if possible, on a spare copy of the file to be changed.'
,cl,cl,
'(Source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
   halt;
  end;

var f_to_replace,replacement_f: file;
    NoRead, NoWritten : word;
    position : longint; wrong_code:integer;
    buf : array [1..4096] of char;
begin
 if paramcount< 3 then help
 else if pos('?', paramstr(1))>0 then help;
 if fsearch(paramstr(1),'')='' then
  writeln('File ',paramstr(1),' not found')
 else
  begin
   assign(f_to_replace,paramstr(1));
   reset(f_to_replace,1);
   if fsearch(paramstr(2),'')='' then
    begin writeln('File ',paramstr(2),' not found'); close(f_to_replace); end
   else
    begin
     assign(replacement_f,paramstr(2));
     reset(replacement_f,1);
     {position:=89088; -- this suited to change a part of help within t602.exe}
     val(paramstr(3),position,wrong_code);
     if wrong_code>0 then writeln('Starting byte given (parameter 3))')
     else
      begin
       seek(replacement_f,position);
       repeat
        BlockRead(replacement_f,buf,4096,NoRead);
        BlockWrite(f_to_replace,buf,NoRead,NoWritten) ;
       until (NoRead<4096) or (NoRead<>NoWritten);
       close (f_to_replace); close(replacement_f);
      end;
    end;
  end;
end.
