 {~ String Procedures, Czech, unknown origin, used by R. Novak's programmes ~}

unit OTP;
{ Jednotka pro jednoduchou praci s retezci.}
interface

type KLAVESY = (END0,HOME0,UP,DOWN,LEFT,RIGHT,PGUP0,PGDN0,DEL0,INS0,ESC0,
                TAB0,BSP0,ENTER0,F11,F22,F33,F44,F55,F66,F77,F88,F99,F100,
                PISMENO0,CISLICE0,SPC0,ALFANUM0,ZBYTEK0 );


procedure CTIZNAKY(var ZNAK:char;var KL:KLAVESY);{cteni jednoho znaku}
procedure DELMEZ(var RETEZ:string);{vymazani mezer z retezce}
procedure UPSTR(var VEL:string); {prevod pismen v retezci na velka}
procedure STR0(CISLO:real;CELKEM,DESMIST:Byte;var RET:string);
function  EREAD(var VYSTUP:string;DELKA:Byte):KLAVESY;
procedure FREAD(var VYSTUP:string;DELKA:Byte); {analogie read ale s editaci}
procedure FREADLN(var A:string;DELKA:Byte);  {analogie readln s editaci}
procedure READUP(var A:string;DELKA:Byte);
procedure READLNUP(var A:string;DELKA:Byte);
function  EREADUP( var VYSTUP:string;DELKA:Byte):KLAVESY;

var CTRLZN : KLAVESY;

implementation

uses Crt;


type TYPCHAR = record
                L : Byte;
                C : array[1..80] of char;
               end;


function EREAD ( var VYSTUP : string; DELKA : Byte ) : KLAVESY;
{analogie prikazu read, ale je schopen i editace}

var TZN : KLAVESY;          {typ klavesy z hlavniho programu}
    ZN : char;              {znakove zobrazeni klavesy}
    P : Byte   ;            {aktualni poloha kurzoru od zacatku retezce}
    XP,                     {pocatecni souradnice kurzoru v X}
    YP : 1..80;             {  -"-        -"-       -"-   v Y}
    X : 1..80;              {aktualmi poloha v X}
    N : 0..80;              {ridici promenna}
    RET : TYPCHAR absolute VYSTUP;

begin
if DELKA=0 then RunError(233);
if RET.L<>DELKA then
  for N:=RET.L+1 to DELKA do RET.C[N]:=' ';
RET.L:=DELKA;
XP:=WhereX; YP:=WhereY;
write(VYSTUP);
N:=RET.L;
while (RET.C[N]=' ')and(N>1) do N:=N-1;
if N=RET.L then N:=N-1;
if RET.C[1]=' ' then N:=0;
GotoXY(N+XP,YP);
repeat
  X:=WhereX;  P:=X-XP+1;
  CTIZNAKY(ZN,TZN);
  if TZN in [PISMENO0,CISLICE0,SPC0,ALFANUM0,ZBYTEK0] then begin
    Insert(ZN,VYSTUP,P);
    RET.L:=RET.L-1;
    GotoXY(XP,YP);
    write(VYSTUP);
    if P<RET.L then GotoXY(X+1,YP) else GotoXY(X,YP); end;
  if TZN in [END0] then begin
    N:=RET.L;
    while (RET.C[N]=' ')and(N>1) do N:=N-1;
    if N=RET.L then N:=N-1;
    {if RET.C[1]=' ' then N:=0;}
    GotoXY(N+XP,YP); end;
  if TZN in [HOME0] then GotoXY(XP,YP);
  if (TZN in [LEFT,BSP0])and(P>1) then GotoXY(X-1,YP);
  if (TZN in [RIGHT])and(P<RET.L) then GotoXY(X+1,YP);
  if TZN in [DEL0,BSP0] then
    if not((TZN in [BSP0])and(P=1)) then begin
      if (TZN in [BSP0])and(P>1) then begin P:=P-1; X:=X-1; end;
      Delete(VYSTUP,P,1);
      with RET do begin
        L:=L+1;
        C[L]:=' '; end;
      GotoXY(XP,YP);
      write(VYSTUP);
      GotoXY(X,YP);
    end;{if}
until TZN in [ENTER0,ESC0,F11..F100];
GotoXY(XP,YP);
if TZN in [ESC0] then VYSTUP:='';

EREAD:=TZN;
end;

procedure FREAD ( var VYSTUP : string; DELKA : Byte );
var A : KLAVESY;
begin
A:=EREAD(VYSTUP,DELKA);
end;

procedure CTIZNAKY(
         var ZNAK : CHAR;
         var KL : KLAVESY );

{ procedura pro cteni znaku z klavesnice }
{ je treba v hlavnim programu zavest tyto typy:}

{type  KLAVESAY = (ENDK,HOME,U,D,L,R,PGUP,PGDN,DEL,INS,ESC,TAB,BSP,ENTER,
                   F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,
                   PISMENO,CISLICE,SPC,ALFANUM,ZBYTEK ); }

begin
ZNAK:=READKEY;
KL:=ZBYTEK0;
if ZNAK<>chr(0) then begin
  if ord(ZNAK)=8 then  KL:=BSP0;
  if ord(ZNAK)=9 then  KL:=TAB0;
  if ord(ZNAK)=13 then  KL:=ENTER0;
  if ord(ZNAK)=27 then  KL:=ESC0;
  if ord(ZNAK)=32 then  KL:=SPC0;
  if ord(ZNAK) in [33..47,58..64,91..95,123..125] then  KL:=ALFANUM0;
  if ord(ZNAK) in [48..57] then  KL:=CISLICE0;
  if ord(ZNAK) in [65..90,97..122] then  KL:=PISMENO0; end
else begin
  ZNAK:=READKEY;
  if ord(ZNAK)=79 then  KL:=END0;
  if ord(ZNAK)=71 then  KL:=HOME0;
  if ord(ZNAK)=72 then  KL:=UP   ;
  if ord(ZNAK)=80 then  KL:=DOWN   ;
  if ord(ZNAK)=75 then  KL:=LEFT   ;
  if ord(ZNAK)=77 then  KL:=RIGHT   ;
  if ord(ZNAK)=73 then  KL:=PGUP0;
  if ord(ZNAK)=81 then  KL:=PGDN0;
  if ord(ZNAK)=83 then  KL:=DEL0 ;
  if ord(ZNAK)=82 then  KL:=INS0 ;
  if ord(ZNAK)=59 then  KL:=F11  ;
  if ord(ZNAK)=60 then  KL:=F22  ;
  if ord(ZNAK)=61 then  KL:=F33  ;
  if ord(ZNAK)=62 then  KL:=F44  ;
  if ord(ZNAK)=63 then  KL:=F55  ;
  if ord(ZNAK)=64 then  KL:=F66  ;
  if ord(ZNAK)=65 then  KL:=F77  ;
  if ord(ZNAK)=66 then  KL:=F88  ;
  if ord(ZNAK)=67 then  KL:=F99  ;
  if ord(ZNAK)=68 then  KL:=F100 ; end;
end;


procedure DELMEZ(var RETEZ:string);
{vymazani mezer z retezce ORETEZ}

var A : TYPCHAR absolute RETEZ;
    POZICE : Byte;

begin
POZICE:=1;
with A do
  while POZICE<=L do
     if C[POZICE]=' ' then
       Delete(RETEZ,POZICE,1)
     else
       POZICE:=POZICE+1;
end;

procedure UPSTR(var VEL : string);
{pretransformuje ve vstupnich datech vsechna pismena na velke}

var A : TYPCHAR absolute VEL;
    K,J : Byte;

begin
with A do
  for J:=1 to L do begin
     K:=ord(C[J]);
     if K in [97..123] then
       C[J]:=chr(K-32); end;
end;


procedure STR0( CISLO : real;
       CELKEM,DESMIST : Byte;
              var RET : string );
{analogie Str, ale misto mezer pred retezcem dava nuly}

var A : TYPCHAR absolute RET;
    N : Byte;
    I : longint;

begin

if DESMIST=0 then begin
  I:=round(CISLO);
  Str(I:CELKEM,RET); end
else
  Str(CISLO:CELKEM:DESMIST,RET);

with A do
 for N:=1 to L do
   if C[N]=' ' then C[N]:='0';
end;


procedure FREADLN(var A:string;DELKA:Byte);
{analogie readln}

begin
FREAD(A,DELKA);
writeln;
end;


procedure READUP(var A:string;DELKA:Byte);
{analogie read, ale konvertuje mala pismena na velka}

begin
FREAD(A,DELKA);
UPSTR(A);
end;


procedure READLNUP(var A:string;DELKA:Byte);
{analogie readln, ale konvertuje mala pismena na velka}

begin
READUP(A,DELKA);
writeln;
end;

function  EREADUP( var VYSTUP:string;DELKA:Byte):KLAVESY;
begin
EREADUP:=EREAD(VYSTUP,DELKA);
UPSTR(VYSTUP);
end;

end.