 {~ Displays an ASCII table with decadic or hexadecimal numbers ~}

program ASCII;
     {by J.Hollan, writes the whole code table 0-255 on the screen}
uses hdconv;
var j,k,k16:byte;
const cl=#13#10;
begin
if paramcount=0 then
 begin
  for j:=0 to 12 do
   write(j:3,chr(j),' ');
  write(13:3,chr(13));
  write(14:3,chr(14),' ');
  write(15:3,chr(15));
  writeln;
  k16:=16;
  for j:=0 to 14 do write(k16+j:3,chr(k16+j),' ');
  write(k16+15:3,chr(k16+15));
  writeln(#10);
  for k:=2 to 7 do
   begin
    k16:=k*16;
    for j:=0 to 14 do write(k16+j:3,chr(k16+j),' ');
    write(k16+15:3,chr(k16+15));
    writeln;
   end;
  writeln;
  for k:=8 to 15 do
   begin
    k16:=k*16;
    for j:=0 to 14 do write(k16+j:3,chr(k16+j),' ');
    write(k16+15:3,chr(k16+15));
    writeln;
   end;
  writeln(cl,
   '(ASCII H would give the numbers as hexadecimal)');
 end
else
 if (pos('?',paramstr(1))>0)
 or (pos('-',paramstr(1))>0)
 or (pos('/',paramstr(1))>0)
  then
   writeln(cl,
   ' ASCII    writes a table of characters 0 to 255 on the screen,',cl,
   ' ASCII H  would give the numbers as hexadecimal',cl,cl,
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)')
 else
 begin
  for j:=0 to 12 do begin decadic:=j; write(dectohex,' ',chr(j),'  ') end;
  write('D ',chr(13));
  write('E ',chr(14),'  ');
  write('F ',chr(15));
  writeln;
  k16:=16;
  for j:=0 to 14 do begin decadic:=k16+j; write(dectohex,' ',chr(k16+j),' ') end;
  decadic:=k16+15; write(dectohex,' ',chr(k16+15));
  writeln(#10);
  for k:=2 to 7 do
   begin
    k16:=k*16;
    for j:=0 to 14 do begin decadic:=k16+j; write(dectohex,' ',chr(k16+j),' ') end;
    decadic:=k16+15; write(dectohex,' ',chr(k16+15));
    writeln;
   end;
  writeln;
  for k:=8 to 15 do
   begin
    k16:=k*16;
    for j:=0 to 14 do begin decadic:=k16+j; write(dectohex,' ',chr(k16+j),' ') end;
    decadic:=k16+15; write(dectohex,' ',chr(k16+15));
    writeln;
   end;
 end;
end.
